## foremost 0.69

=== Makefile ===

CC = gcc
CC_OPTS = -Wall -O2
GOAL = foremost

# These options are used for cross-compiling for Windows via linux.
# If you don't plan on doing this, don't worry about them
CROSSCC = /usr/local/cross-tools/i386-mingw32msvc/bin/gcc
CROSSOPT = -Wall -O2 -D__WIN32
CROSSLINK = -liberty
CROSSGOAL = $(GOAL).exe

# You shouldn't need to change anything below this line
#---------------------------------------------------------------------

# Where foremost gets installed
BIN = /usr/local/bin
MAN = /usr/local/man/man1

# This should be commented out when debugging is done
#CC_OPTS += -D__DEBUG -ggdb

# This is used when generating packages
VERSION = 0.69

# Generic "how to compile C files"
CC += $(CC_OPTS) 
  .c.o: 
	$(CC) -c $<

# Definitions we'll need later (and that should almost never change)
HEADER_FILES = foremost.h
SRC =  helpers.c files.c foremost.c dig.c
OBJS =  helpers.o foremost.o files.o dig.o

all: linux

openbsd: CC+= -D__OPENBSD -D__GLIBC__ 
openbsd: $(GOAL)

linux: CC += -D__LINUX 
linux: $(GOAL)

# This version of foremost will compile under Cygwin or mingw.
# Not all features have been fully tested on windows.
win32: CC += $(CROSSOPT) 
win32: $(SRC) $(HEADER_FILES)
	$(CC) -o $(CROSSGOAL) $(SRC) $(CROSSLINK)

cross-win: $(CROSSCC) += $(CROSSOPT)
cross-win: $(SRC) $(HEADER_FILES)
	$(CROSSCC) -o $(CROSSGOAL) $(SRC) $(CROSSLINK)

$(GOAL): $(OBJS) 
	$(CC) -o $(GOAL) $(OBJS)

install: all
	install -CDm 755 $(GOAL)   $(BIN)/$(GOAL)
	install -CDm 644 $(GOAL).1 $(MAN)/$(GOAL).1

uninstall:
	rm -f $(BIN)/$(GOAL) $(MAN)/$(GOAL).1

rpms:
	rpm -ba rpm/foremost-$(VERSION)-1.spec
	cp /usr/src/redhat/RPMS/i386/foremost-$(VERSION)-1.i386.rpm rpm
	cp /usr/src/redhat/SRPMS/foremost-$(VERSION)-1.src.rpm rpm
	chown jessek.jessek rpm/*


foremost.o: foremost.c $(HEADER_FILES)
helpers.o: helpers.c $(HEADER_FILES)
files.o: files.c $(HEADER_FILES)

# This is used for debugging
preflight:
	grep -n RBF *.h *.c

nice:
	rm -f *~
	rm -rf output foremost-output out


clean: nice
	rm -f $(OBJS) $(GOAL) $(GOAL).exe core *.core

#-------------------------------------------------------------------------

DEST_DIR = $(GOAL)-$(VERSION)
TAR_FILE = $(DEST_DIR).tar
DOCS = CHANGES TODO README
PKG_FILES = $(SRC) $(HEADER_FILES) foremost.conf foremost.1 Makefile $(DOCS)

# This packages me up to send to somebody else
package:
	rm -f $(TAR_FILE) $(TAR_FILE).gz
	mkdir $(DEST_DIR)
	cp $(PKG_FILES) $(DEST_DIR)
	tar cvf $(TAR_FILE) $(DEST_DIR)
	rm -rf $(DEST_DIR)
	gzip $(TAR_FILE)

publish: package
	cp $(TAR_FILE).gz /home/jessek/rnd/Foremost/

## foremost 1.2

=== Makefile ===

RAW_CC = gcc
RAW_FLAGS = -Wall -O2
LINK_OPT = 
VERSION = 1.2
# Try to determine the host system
SYS := $(shell uname -s | tr -d "[0-9]" | tr -d "-" | tr "[A-Z]" "[a-z]")


# You can cross compile this program for Win32 using Linux and the 
# MinGW compiler. See the README for details. If you have already
# installed MinGW, put the location ($PREFIX) here:
CR_BASE = /usr/local/cross-tools/i386-mingw32msvc/bin

# You shouldn't need to change anything below this line
#---------------------------------------------------------------------

# This should be commented out when debugging is done
#RAW_FLAGS += -D__DEBUG -ggdb

NAME = foremost
MAN_PAGES = $(NAME).1

RAW_FLAGS += -DVERSION=\"$(VERSION)\"

# Where we get installed
BIN = /usr/local/bin
MAN = /usr/local/man/man1
CONF= /usr/local/etc
# Setup for compiling and cross-compiling for Windows
# The CR_ prefix refers to cross compiling from OSX to Windows
CR_CC = $(CR_BASE)/gcc
CR_OPT = $(RAW_FLAGS) -D__WIN32
CR_LINK = -liberty
CR_STRIP = $(CR_BASE)/strip
CR_GOAL = $(NAME).exe
WINCC = $(RAW_CC) $(RAW_FLAGS) -D__WIN32

# Generic "how to compile C files"
CC = $(RAW_CC) $(RAW_FLAGS) -D__UNIX
.c.o:   
	$(CC) -c $<


# Definitions we'll need later (and that should rarely change)
HEADER_FILES = main.h ole.h extract.h
SRC =  main.c state.c helpers.c config.c cli.c engine.c dir.c extract.c api.c
OBJ =  main.o state.o helpers.o config.o cli.o engine.o dir.o extract.o api.o
DOCS = Makefile README CHANGES $(MAN_PAGES) foremost.conf
WINDOC = README.txt CHANGES.txt


#---------------------------------------------------------------------
# OPERATING SYSTEM DIRECTIVES
#---------------------------------------------------------------------

all: $(SYS) goals

goals: $(NAME)

linux: CC += -D__LINUX -DLARGEFILE64_SOURCE -D_FILE_OFFSET_BITS=64
linux: goals

sunos: solaris
solaris: CC += -D__SOLARIS -D_LARGEFILE_SOURCE -D_FILE_OFFSET_BITS=64
solaris: goals

darwin: CC += -D__MACOSX
darwin: goals

mac: CC += -D__MACOSX
mac: goals

netbsd:  unix
openbsd: unix
freebsd: unix
unix: goals

#Fore some reasons BSD variants get confused on how to build engine.o
#so lets make it real clear

engine.o:       engine.c
	$(CC) -c engine.c


# Common commands for compiling versions for Windows. 
# See cross and windows directives below.
win_general: LINK_OPT = $(CR_LINK)
win_general: GOAL = $(CR_GOAL)
win_general: goals
	$(STRIP) $(CR_GOAL)

# Cross compiling from Linux to Windows. See README for more info
cross: CC = $(CR_CC) $(CR_OPT)
cross: STRIP = $(CR_STRIP)
cross: win_general

# See the README for information on Windows compilation
windows: CC = $(WINCC)
windows: STRIP = strip
windows: win_general 

cygwin_nt.: unix
cygwin: unix


#---------------------------------------------------------------------
# COMPILE THE PROGRAMS
#   This section must be updated each time you add an algorithm
#---------------------------------------------------------------------

foremost: $(OBJ)
	$(CC) $(OBJ) -o $(NAME) $(LINK_OPT)


#---------------------------------------------------------------------
# INSTALLATION AND REMOVAL 
#---------------------------------------------------------------------

install: goals
	install -m 755 $(NAME) $(BIN)
	install -m 444 $(MAN_PAGES) $(MAN)
	install -m 444 foremost.conf $(CONF)
macinstall: BIN = /usr/local/bin/
macinstall: MAN = /usr/share/man/man1/
macinstall: CONF = /usr/local/etc/
macinstall: mac install


uninstall:
	rm -f -- $(BIN)/{$(RM_GOALS)}
	rm -f -- $(MAN)/{$(RM_DOCS)}

macuninstall: BIN = /usr/bin
macuninstall: MAN = /usr/share/man/man1
macuninstall: uninstall

#---------------------------------------------------------------------
# CLEAN UP
#---------------------------------------------------------------------

# This is used for debugging
preflight:
	grep -n RBF *.1 *.h *.c README CHANGES

nice:
	rm -f -- *~

clean: nice
	rm -f -- *.o
	rm -f -- $(CR_GOAL) $(NAME) $(WIN_DOC)
	rm -f -- $(TAR_FILE).gz $(DEST_DIR).zip $(DEST_DIR).zip.gpg

#-------------------------------------------------------------------------
# MAKING PACKAGES
#-------------------------------------------------------------------------

EXTRA_FILES = 
DEST_DIR = $(NAME)-$(VERSION)
TAR_FILE = $(DEST_DIR).tar
PKG_FILES = $(SRC) $(HEADER_FILES) $(DOCS) $(EXTRA_FILES)

# This packages me up to send to somebody else
package: clean
	rm -f $(TAR_FILE) $(TAR_FILE).gz
	mkdir $(DEST_DIR)
	cp $(PKG_FILES) $(DEST_DIR)
	tar cvf $(TAR_FILE) $(DEST_DIR)
	rm -rf $(DEST_DIR)
	gzip $(TAR_FILE)


# This Makefile is designed for Mac OSX to package the file. 
# To do this on a linux box, The big line below starting with "/usr/bin/tbl"
# should be replaced with:
#
#	man ./$(MD5GOAL).1 | col -bx > README.txt
#
# and the "flip -d" command should be replaced with dos2unix
#
# The flip command can be found at:
# http://ccrma-www.stanford.edu/~craig/utility/flip/#
win-doc:
	/usr/bin/tbl ./$(MD5GOAL).1 | /usr/bin/groff -S -Wall -mtty-char -mandoc -Tascii | /usr/bin/col > README.txt
	cp CHANGES CHANGES.txt
	flip -d $(WINDOC)

cross-pkg: clean cross win-doc
	rm -f $(DEST_DIR).zip
	zip $(DEST_DIR).zip $(CR_MD5GOAL) $(CR_SHA1GOAL) $(CR_SHA256GOAL) $(WINDOC)
	rm -f $(WINDOC)

world: package cross-pkg

## foremost 1.3

=== Makefile ===
--- 
+++ 
@@ -2,7 +2,7 @@
 RAW_CC = gcc
 RAW_FLAGS = -Wall -O2
 LINK_OPT = 
-VERSION = 1.2
+VERSION = 1.3
 # Try to determine the host system
 SYS := $(shell uname -s | tr -d "[0-9]" | tr -d "-" | tr "[A-Z]" "[a-z]")

## foremost 1.5

=== Makefile ===
--- 
+++ 
@@ -2,7 +2,7 @@
 RAW_CC = gcc
 RAW_FLAGS = -Wall -O2
 LINK_OPT = 
-VERSION = 1.3
+VERSION = 1.5
 # Try to determine the host system
 SYS := $(shell uname -s | tr -d "[0-9]" | tr -d "-" | tr "[A-Z]" "[a-z]")

## foremost 1.5.3

=== Makefile ===
--- 
+++ 
@@ -2,7 +2,7 @@
 RAW_CC = gcc
 RAW_FLAGS = -Wall -O2
 LINK_OPT = 
-VERSION = 1.5
+VERSION = 1.5.3
 # Try to determine the host system
 SYS := $(shell uname -s | tr -d "[0-9]" | tr -d "-" | tr "[A-Z]" "[a-z]")

## foremost 1.5.4

=== Makefile ===
--- 
+++ 
@@ -2,7 +2,7 @@
 RAW_CC = gcc
 RAW_FLAGS = -Wall -O2
 LINK_OPT = 
-VERSION = 1.5.3
+VERSION = 1.5.4
 # Try to determine the host system
 SYS := $(shell uname -s | tr -d "[0-9]" | tr -d "-" | tr "[A-Z]" "[a-z]")

## foremost 1.5.5

=== Makefile ===
--- 
+++ 
@@ -2,7 +2,7 @@
 RAW_CC = gcc
 RAW_FLAGS = -Wall -O2
 LINK_OPT = 
-VERSION = 1.5.4
+VERSION = 1.5.5
 # Try to determine the host system
 SYS := $(shell uname -s | tr -d "[0-9]" | tr -d "-" | tr "[A-Z]" "[a-z]")
 
@@ -19,13 +19,13 @@
 #RAW_FLAGS += -D__DEBUG -ggdb
 
 NAME = foremost
-MAN_PAGES = $(NAME).1
+MAN_PAGES = $(NAME).8.gz
 
 RAW_FLAGS += -DVERSION=\"$(VERSION)\"
 
 # Where we get installed
 BIN = /usr/local/bin
-MAN = /usr/local/man/man1
+MAN = /usr/share/man/man8
 CONF= /usr/local/etc
 # Setup for compiling and cross-compiling for Windows
 # The CR_ prefix refers to cross compiling from OSX to Windows

## foremost 1.5.7

=== Makefile ===
--- 
+++ 
@@ -2,7 +2,7 @@
 RAW_CC = gcc
 RAW_FLAGS = -Wall -O2
 LINK_OPT = 
-VERSION = 1.5.5
+VERSION = 1.5.7
 # Try to determine the host system
 SYS := $(shell uname -s | tr -d "[0-9]" | tr -d "-" | tr "[A-Z]" "[a-z]")

=== debian/changelog ===
foremost (1.5.7-9.1) unstable; urgency=medium

  * Non-maintainer upload.
  * debian/rules: added DEB_CFLAGS_MAINT_APPEND variable as a workaround to fix
    a FTBFS with GCC-10. (Closes: #957219)

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Wed, 19 Aug 2020 15:38:47 -0300

foremost (1.5.7-9) unstable; urgency=medium

  * Fix extra byte at the tail of recovered zip files if -t all is
    used. Thanks to Maxim Nikulin for reporting the bug and sending the
    patch. (Closes: #928070)
  * Use debhelper 12.
  * Bump standards version to 4.3.0, no changes required.

 -- Raúl Benencia <rul@kalgan.cc>  Wed, 12 Jun 2019 08:08:06 -0700

foremost (1.5.7-8) unstable; urgency=medium

  * Enforce limit on the config file lines length. (Closes: #833639)
  * Enforce limit on the amount of possible config file
    entries. (Closes: #833642)
  * Update Standards Version to 4.1.5. No changes required.

 -- Raúl Benencia <rul@kalgan.cc>  Sat, 14 Jul 2018 08:57:14 -0700

foremost (1.5.7-7) sid; urgency=medium

  * Fix build to honor flags set by dh. Thanks to Yann Dirson for
    reporting the bug and sending part of the patch. (Closes: #833638, #850926)
  * Update Homepage and Vcs fields on d/control.
  * Update debhelper compat version to 11. No changes required.
  * Update Standards-Version. No changes required.
  * Fix insecure-copyright-format-uri and update source code reference in
    d/copyright file.
  * Prepend numbers in patches file names.

 -- Raúl Benencia <rul@kalgan.cc>  Thu, 14 Jun 2018 07:40:30 -0700

foremost (1.5.7-6) sid; urgency=low

  * Update man page with newly supported format. (Closes: #777260)
  * Bump standars version to 3.9.6, no changes required.
  * Update Vcs-Git.

 -- Raúl Benencia <rul@kalgan.cc>  Mon, 23 Feb 2015 09:39:02 -0300

foremost (1.5.7-5) unstable; urgency=medium

  * Update maintainer email address.
  * Include new VCS control fields.
  * Fix FTBFS caused by dpkg update. Thanks Juhani Numminen. (Closes: #753184)
  * Bump standards version to 3.9.5, no changes.

 -- Raúl Benencia <rul@kalgan.cc>  Thu, 03 Jul 2014 14:03:02 -0300

foremost (1.5.7-4) unstable; urgency=low

  * Fix FTBFS on hurd by defining missing PATH_MAX macro

 -- Raúl Benencia <rbenencia@linti.unlp.edu.ar>  Thu, 12 Jul 2012 09:47:42 -0300

foremost (1.5.7-3) unstable; urgency=low

  * Fix lintian hardening warnings
  * Fix build system for hurd and freebsd

 -- Raúl Benencia <rbenencia@linti.unlp.edu.ar>  Tue, 10 Jul 2012 00:48:13 -0300

foremost (1.5.7-2) unstable; urgency=low

  * New maintainer (Closes: #661488)
  * Bump standards version to 3.9.3.
  * Upgraded debian/copyright to a machine-readable format.
  * Renamed and cleaned debian-changes-1.5.7-1 patch.
  * Added watch file

 -- Raúl Benencia <rbenencia@linti.unlp.edu.ar>  Mon, 14 May 2012 11:31:03 -0300

foremost (1.5.7-1) unstable; urgency=low

  * New upstream version.
  * Bump standards version to 3.8.4.
  * Switch to dpkg-source format version 3 (quilt).

 -- Gürkan Sengün <gurkan@phys.ethz.ch>  Fri, 26 Mar 2010 16:06:19 +0100

foremost (1.5.6-1) unstable; urgency=low

  * New upstream version.
  * Bump standards version.
  * Bump debhelper version.
  * Updated debian/copyright.

 -- Gürkan Sengün <gurkan@phys.ethz.ch>  Fri, 08 May 2009 00:39:18 +0200

foremost (1.5.5-1) unstable; urgency=low

  * New upstream version.

 -- Gürkan Sengün <gurkan@phys.ethz.ch>  Thu, 08 Jan 2009 11:04:43 +0100

foremost (1.5.4-1) unstable; urgency=low

  * New upstream version.
  * Updated my email address.

 -- Gürkan Sengün <gurkan@phys.ethz.ch>  Tue, 20 May 2008 09:31:54 +0200

foremost (1.5.3-1) unstable; urgency=low

  * New upstream version. (Closes: #454588)
  * debian/control: Updated standards version.

 -- Gürkan Sengün <gurkan@linuks.mine.nu>  Thu, 06 Dec 2007 14:28:56 +0100

foremost (1.5.2-1) unstable; urgency=low

  * New upstream version.

 -- Gürkan Sengün <gurkan@linuks.mine.nu>  Fri, 09 Nov 2007 00:28:14 +0100

foremost (1.5.1-1) unstable; urgency=low

  * New upstream version. (Closes: #441924)

 -- Gürkan Sengün <gurkan@linuks.mine.nu>  Thu, 01 Nov 2007 00:05:20 +0100

foremost (1.5-1) unstable; urgency=low

  * New upstream version.

 -- Gürkan Sengün <gurkan@linuks.mine.nu>  Thu, 26 Apr 2007 00:14:04 +0200

foremost (1.4-1) unstable; urgency=low

  * New upstream verion.

 -- Gürkan Sengün <gurkan@linuks.mine.nu>  Sun, 18 Feb 2007 09:45:26 +0100

foremost (1.3-1) unstable; urgency=low

  * New upstream version.
  * Bump standards version (no changes needed).
  * Bump DH compat level to 5.
  * Updated debian/copyright.
  * Removed co-maintainer.

 -- Gürkan Sengün <gurkan@linuks.mine.nu>  Sun,  3 Sep 2006 19:57:55 +0200

foremost (1.2-1) unstable; urgency=low

  * New upstream version.

 -- Gürkan Sengün <gurkan@linuks.mine.nu>  Thu,  4 May 2006 14:07:34 +0200

foremost (1.1-2) unstable; urgency=low

  * Look in /etc for config file by default.
  * Added homepage to long description.

 -- Gürkan Sengün <gurkan@linuks.mine.nu>  Wed, 12 Apr 2006 11:00:56 +0200

foremost (1.1-1) unstable; urgency=low

  * New upstream version. (Closes: #355808)
  * New Maintainer with permission of co-maintainer.

 -- Gürkan Sengün <gurkan@linuks.mine.nu>  Sun,  2 Apr 2006 18:12:56 +0200

foremost (0.69-1) unstable; urgency=low

  * Initial release (closes: #280193)

 -- Niall Sheridan <niall@blacknight.ie>  Fri, 19 Nov 2004 13:56:48 +0000

=== debian/control ===
Source: foremost
Section: admin
Priority: optional
Maintainer: Raúl Benencia <rul@kalgan.cc>
Build-Depends: debhelper (>= 12),
Standards-Version: 4.3.0
Homepage: https://sourceforge.net/projects/foremost/
Vcs-Git: https://salsa.debian.org/rul-guest/foremost.git
Vcs-Browser: https://salsa.debian.org/rul-guest/foremost

Package: foremost
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: forensic program to recover lost files
 Foremost is a forensic program to recover lost files based on
 their headers, footers, and internal data structures.
 .
 Foremost can work on image files, such as those generated by dd,
 Safeback, Encase, etc, or directly on a drive. The headers and
 footers can be specified by a configuration file or you can use
 command line switches to specify built-in file types. These built-in
 types look at the data structures of a given file format allowing
 for a more reliable and faster recovery.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

# Workaround for #957219
export DEB_CFLAGS_MAINT_APPEND = -fcommon

%:
	dh $@

override_dh_auto_install:
	install -D -m 644 foremost.conf $(CURDIR)/debian/foremost/etc/foremost.conf
	install -D -m 755 foremost $(CURDIR)/debian/foremost/usr/bin/foremost
